using DG.Tweening;
using System.Collections;
using System.Collections.Generic;
using UnityEngine;
using UnityEngine.UI;

public class UI_ComputerSystemJLZXJCPanel : UI_ComputerSystemBasePanel
{
    public string triggerName = "";

    public GameObject TransResultPanel;//
    public GameObject InterrogationPanel;//ٲ

    public GameObject ResultPanel;//

    public GameObject transcribeBtn;//͸ť
    public GameObject interrogationBtn;//ٲⰴť

    bool IsTranscribed = false;//Ѿ͸
    bool IsInterrogation = false;//Ѿٲ

    Tween tween3;
    Tween tween4;
    /// <summary>
    /// ѯѡк
    /// </summary>
    /// <param name="b"></param>
    public void ActiveBtn(bool b)
    {
        transcribeBtn.SetActive(b);
        interrogationBtn.SetActive(b);
        if (GameManager.RunModelMgr.ModeType == E_ModeType.Study)
        {
            GameObject tip3 = ToolFuncManager.GetChild(this.transform, "ImageTips_3").gameObject;
            ActiveEmbededTip(tip3, tween3);

            GameObject tip4 = ToolFuncManager.GetChild(this.transform, "ImageTips_4").gameObject;
            ActiveEmbededTip(tip4, tween4);
        }
    }

    public override void ShowMe()
    {
        base.ShowMe();
        TransResultPanel.SetActive(false);//͸ر
        InterrogationPanel.SetActive(false);//ٲر
        ResultPanel.SetActive(false);//ر
        transcribeBtn.SetActive(false);//͸ťر
        interrogationBtn.SetActive(false);//ٲⰴťر

        IsTranscribed       = false;//͸Ϊfalse
        IsInterrogation     = false;//ٲΪfalse
        GetControl<Button>("closeBtn").gameObject.SetActive(true);
    }

    /// <summary>
    /// ť
    /// </summary>
    /// <param name="btnName"></param>
    protected override void OnClick(string btnName)
    {
        base.OnClick(btnName);
        switch (btnName)
        {
            case "backBtn":
                GameManager.UIMgr.HidePanel<UI_ComputerSystemJLZXJCPanel>();
                GameManager.UIMgr.ShowPanel<UI_ComputerSystemHomePagePanel>();
                break;
            case "searchBtn":
                ResultPanel.SetActive(true);//ʾ
                if (GameManager.RunModelMgr.ModeType == E_ModeType.Study)
                {
                    ToolFuncManager.GetChild(this.transform, "ImageTips_1").gameObject.SetActive(false);//ʾ
                    GameObject tip2 = ToolFuncManager.GetChild(this.transform, "ImageTips_2").gameObject;
                    ActiveEmbededTip(tip2);
                }
                break;
            case "transcribeBtn":
                if (!IsTranscribed)
                {
                    StartCoroutine(Transcribe());
                }
                break;
            case "interrogationBtn":
                if (!IsInterrogation)
                {
                    StartCoroutine(Interrogation());
                }
                break;
            case "closeBtn":
                GameManager.UIMgr.HidePanel<UI_ComputerSystemJLZXJCPanel>();
                if (IsTranscribed && IsInterrogation)
                {
                    GameManager.ProcessMgr.IsRightSubProcessStepsTriggerID(triggerName, true);
                    ScoreManager.instance.Check(triggerName, "͸");
                    if (GameManager.RunModelMgr.ModeType == E_ModeType.Study)
                    {
                        if (tween != null)
                            tween.Kill(true);
                        GameObject tip5 = ToolFuncManager.GetChild(this.transform, "ImageTips_5").gameObject;
                        tip5.SetActive(false);
                    }
                }
                break;
        }
    }

    /// <summary>
    /// ͸
    /// </summary>
    /// <returns></returns>
    protected IEnumerator Transcribe()
    {
        RectTransform   ResTip_Up       = ToolFuncManager.GetChild(TransResultPanel.transform, "ResTip_Up").GetComponent<RectTransform>();
        RectTransform   ResTip_Down     = ToolFuncManager.GetChild(TransResultPanel.transform, "ResTip_Down").GetComponent<RectTransform>();
        Vector3         upPos           = ResTip_Up.localPosition;
        Vector3         downPos         = ResTip_Down.localPosition;
        ResTip_Up.localPosition         = new Vector3(upPos.x, upPos.y + 60, upPos.z);
        ResTip_Down.localPosition       = new Vector3(downPos.x, downPos.y + 60, downPos.z);

        TransResultPanel.SetActive(true);//ʾ͸
        ResTip_Up.DOLocalMove(upPos, 0.4f);
        ResTip_Down.DOLocalMove(downPos, 0.4f);

        yield return new WaitForSeconds(3);
        TransResultPanel.SetActive(false);//͸
        IsTranscribed = true;//͸Ϊtrue
        if (GameManager.RunModelMgr.ModeType == E_ModeType.Study)
        {
            if (tween3 != null)
                tween3.Kill(true);
            GameObject tip3 = ToolFuncManager.GetChild(this.transform, "ImageTips_3").gameObject;
            tip3.SetActive(false);
            if (IsInterrogation)
            {
                GameObject tip5 = ToolFuncManager.GetChild(this.transform, "ImageTips_5").gameObject;
                ActiveEmbededTip(tip5);
            }
        }
    }

    protected IEnumerator Interrogation()
    {
        RectTransform   ResTip_Up       = ToolFuncManager.GetChild(InterrogationPanel.transform, "ResTip_Up").GetComponent<RectTransform>();
        RectTransform   ResTip_Down     = ToolFuncManager.GetChild(InterrogationPanel.transform, "ResTip_Down").GetComponent<RectTransform>();
        Vector3         upPos           = ResTip_Up.localPosition;
        Vector3         downPos         = ResTip_Down.localPosition;
        ResTip_Up.localPosition         = new Vector3(upPos.x, upPos.y + 60, upPos.z);
        ResTip_Down.localPosition       = new Vector3(downPos.x, downPos.y + 60, downPos.z);

        InterrogationPanel.SetActive(true);//ʾٲ
        ResTip_Up.DOLocalMove(upPos, 0.4f);
        ResTip_Down.DOLocalMove(downPos, 0.4f);

        yield return new WaitForSeconds(3);
        InterrogationPanel.SetActive(false);//ٲ
        IsInterrogation = true;//ٲΪtrue
        if (GameManager.RunModelMgr.ModeType == E_ModeType.Study)
        {
            if (tween4 != null)
                tween4.Kill(true);
            GameObject tip4 = ToolFuncManager.GetChild(this.transform, "ImageTips_4").gameObject;
            tip4.SetActive(false);
            if (IsTranscribed)
            {
                GameObject tip5 = ToolFuncManager.GetChild(this.transform, "ImageTips_5").gameObject;
                ActiveEmbededTip(tip5);
            }
        }
    }
}
