using System.Collections;
using System.Collections.Generic;
using UnityEngine;
using UnityEngine.UI;

public class UI_ConnectStation : BasePanel
{
    public string triggerName;

    //bool reinstalled = false;
    Device_Control dc = null;
    public Device_Collector collector;
    public Device_Sundries sundries;

    public override void ShowMe()
    {
        base.ShowMe();
        //dc = FindObjectOfType<Device_Control_4001>();
        dc = FindObjectOfType<Device_Control>();
        collector = dc.GetComponentInChildren<Device_Collector>(true);
        sundries = dc.GetComponentInChildren<Device_Sundries>(true);

        collector.plug.onPlugToClose += HighlightBtn;
        if (GameManager.RunModelMgr.ModeType == E_ModeType.Study)
        {
            GetControl<Button>("connectBtn").interactable = false;
        }
    }

    public override void HideMe()
    {
        base.HideMe();
        collector.plug.onPlugToClose -= HighlightBtn;
    }

    /// <summary>
    /// ѧϰģʽ£ť
    /// </summary>
    void HighlightBtn()
    {
        GetControl<Button>("connectBtn").interactable = true;
        if (GameManager.RunModelMgr.ModeType == E_ModeType.Study)
        {
            if (collector != null && !collector.gameObject.name.Contains("ԭ"))
            {
                collector.plug.transform.GetComponent<BoxCollider>().enabled = false;
            }
            RectTransform rect = GameObject.Find("connectBtn").GetComponent<RectTransform>();
            GameManager.UIMgr.imageTips.ShowTips(rect);
        }
    }

    /// <summary>
    /// ť
    /// </summary>
    /// <param name="btnName"></param>
    protected override void OnClick(string btnName)
    {
        switch (btnName)
        {
            case "connectBtn":
                if (collector != null && !collector.gameObject.name.Contains("ԭ"))
                {
                    GameManager.UIMgr.ShowPanel<UI_PlayerSessionPanel>(E_UI_Layer.Mid, (panel) =>
                    {
                        GameManager.EventMgr.EventTrigger<bool>(Enum_EventType.PlayerCanMove, false);
                        panel.Init(triggerName, "ãxxxͻɼϣվԱûг¼ݡ", StationLeadTalk, 0);
                    });
                }
                else
                {
                    TipPanel.ShowTip("ٲʧ");
                }
                break;
        }
    }

    private void StationLeadTalk(string triggerName)
    {
        //if (GameManager.ProcessMgr.IsRightSubProcessStepsTriggerID(triggerName, false) == 0)
        //{
            GameManager.UIMgr.ShowPanel<UI_CustomSessionPanel>(E_UI_Layer.Mid, (panel) =>
            {
                
                panel.Init(triggerName, "ãݳ¼", "̨", 1, WorkerReply);
            });
        //}
    }

    private void WorkerReply(string triggerName)
    {
        GameManager.UIMgr.HidePanel<UI_CustomSessionPanel>();
        GameManager.UIMgr.ShowPanel<UI_PlayerSessionPanel>(E_UI_Layer.Mid, (panel) =>
        {
            panel.Init(triggerName, "õ", (str) => {
                //GameManager.EventMgr.RemoveEventListener<GameObject>(Enum_EventType.TakeOutAndRetrievingTheTools, TakeOutAndRetrievingTheTools_1);
                GameManager.UIMgr.HidePanel<UI_PlayerSessionPanel>();
                GameManager.EventMgr.EventTrigger<bool>(Enum_EventType.PlayerCanMove, true);
                if (GameManager.ProcessMgr.IsRightSubProcessStepsTriggerID(triggerName, true) == 0);
                {
                    ScoreManager.instance.Check(triggerName, "ɼϴ");
                }
               sundries.gameObject.SetActive(true);
                if (GameManager.RunModelMgr.ModeType == E_ModeType.Study)
                {
                    GetControl<Button>("connectBtn").interactable = false;
                }
            }, 0);
        });
    }
}

